Highlights:
   - **CI/CD workflow**
      - Generate manylinux2014-compatible wheels with CUDA backend in release workflow (#4550) (by **Yi Xu**)
      - Cleanup workspace before window test (#4405) (by **Jian Zeng**)
   - **Command line interface**
      - Fix a few bugs in taichi gallery command (#4548) (by **Zhao Liang**)
   - **Documentation**
      - Adjust CPU GUI document layout (#4605) (by **Peng Yu**)
      - Refactored Type system. (#4584) (by **Vissidarte-Herman**)
      - Fixed broken links. (#4563) (by **Vissidarte-Herman**)
      - Refactored README.md (#4549) (by **Vissidarte-Herman**)
      - Create CODE_OF_CONDUCT (#4564) (by **notginger**)
      - Update syntax.md (#4557) (by **Vissidarte-Herman**)
      - Update docstring for ndrange (#4486) (by **Zhao Liang**)
      - Minor updates: It is recommended to type hint arguments and return values (#4510) (by **Vissidarte-Herman**)
      - Refactored Kernels and functions. (#4496) (by **Vissidarte-Herman**)
      - Add initial variable and fragments (#4457) (by **Justin**)
      - Update docstrings for functions in ops (#4465) (by **Zhao Liang**)
      - Update docstring for functions in misc (#4474) (by **Zhao Liang**)
      - Update docstrings in misc (#4446) (by **Zhao Liang**)
      - Update docstring for functions in operations (#4427) (by **Zhao Liang**)
      - Update PyTorch interface documentation (#4311) (by **Andrew Sun**)
      - Update docstring for functions in operations (#4413) (by **Zhao Liang**)
      - Update docstring for functions in operations (#4392) (by **Zhao Liang**)
      - Fix broken links (#4368) (by **Ye Kuang**)
      - Re-structure the articles: getting-started, gui (#4360) (by **Ye Kuang**)
      - Avoid log(0) problem in _funcs._randn() and update primitive_types.py (#4317) (by **Zhao Liang**)
      - Revise "Why a new programming language" (#4306) (by **Ye Kuang**)
   - **Error messages**
      - Add error message when the number of elements in kernel arguments exceed (#4444) (by **Xiangyun Yang**)
      - Add error for invalid snode size (#4460) (by **Lin Jiang**)
      - Add error messages for wrong type annotations of literals (#4462) (by **Yi Xu**)
      - Remove the mentioning of ti.pyfunc in the error message (#4429) (by **Lin Jiang**)
   - **Language and syntax**
      - Add taichi gallery command for user to choose and run example in gui (#4532) (by **TiGeekMan**)
      - Add ti.serialize and ti.loop_config (#4525) (by **Lin Jiang**)
      - Support simple matrix slicing (#4488) (by **Xiangyun Yang**)
      - Remove legacy ways to construct matrices (#4521) (by **Yi Xu**)
      - Support sparse matrix builder datatype configuration (#4411) (by **Peng Yu**)
      - Support type annotations for literals (#4440) (by **Yi Xu**)
      - Support simple matrix slicing (#4420) (by **Xiangyun Yang**)
      - Support kernel to return a matrix type value (#4062) (by **Xiangyun Yang**)
   - **Vulkan backend**
      - Enable Vulkan device selection when using cuda (#4330) (by **Bo Qiao**)

Full changelog:
   - [lang] Replace keywords in python (#4606) (by **Jiasheng Zhang**)
   - [Doc] Adjust CPU GUI document layout (#4605) (by **Peng Yu**)
   - [Doc] Refactored Type system. (#4584) (by **Vissidarte-Herman**)
   - [lang] Fix py36 block_dim bug (#4601) (by **Jiasheng Zhang**)
   - [ci] Fix release script bug (#4599) (by **Jiasheng Zhang**)
   - [lang] Fix vector matrix ndarray to numpy layout (#4597) (by **Bo Qiao**)
   - [bug] Fix bug that caching kernels with same AST will fail (#4582) (by **PGZXB**)
   - [aot] Support return in vulkan aot (#4593) (by **Ailing**)
   - [ci] Release script add test for tests/python/examples (#4590) (by **Jiasheng Zhang**)
   - [misc] Write version info right after creation of uuid (#4589) (by **Jiasheng Zhang**)
   - [gui] Make GGUI VBO configurable (#4575) (by **Ye Kuang**)
   - [test] Fix ill-formed test_binary_func_ret (#4587) (by **Yi Xu**)
   - Update differences_between_taichi_and_python_programs.md (#4583) (by **Vissidarte-Herman**)
   - [misc] Fix a few warnings (#4572) (by **Ye Kuang**)
   - [aot] Remove redundant module_path argument (#4573) (by **Ailing**)
   - [bug] [opt] Fix some bugs when deal with real function (#4568) (by **Xiangyun Yang**)
   - [build] Guard llvm usage inside TI_WITH_LLVM (#4570) (by **Ailing**)
   - [aot] [refactor] Add make_new_field for Metal (#4559) (by **Bo Qiao**)
   - [llvm] [lang] Add support for multiple return statements in real function (#4536) (by **Lin Jiang**)
   - [test] Add test for offline-cache (#4562) (by **PGZXB**)
   - Format updates (#4567) (by **Vissidarte-Herman**)
   - [aot] Add KernelTemplate interface (#4558) (by **Ye Kuang**)
   - [test] Eliminate the warnings in test suite (#4556) (by **Frost Ming**)
   - [Doc] Fixed broken links. (#4563) (by **Vissidarte-Herman**)
   - [Doc] Refactored README.md (#4549) (by **Vissidarte-Herman**)
   - [Doc] Create CODE_OF_CONDUCT (#4564) (by **notginger**)
   - [misc] Reset counters in Program::finalize() (#4561) (by **PGZXB**)
   - [misc] Add TI_CI env to CI/CD (#4551) (by **Jiasheng Zhang**)
   - [ir] Add basic tests for Block (#4553) (by **Ye Kuang**)
   - [refactor] Fix error message (#4552) (by **Ye Kuang**)
   - [Doc] Update syntax.md (#4557) (by **Vissidarte-Herman**)
   - [gui] Hack to make GUI.close() work on macOS (#4555) (by **Ye Kuang**)
   - [aot] Fix get_kernel API semantics (#4554) (by **Ye Kuang**)
   - [opt] Support offline-cache for kernel with arch=cpu (#4500) (by **PGZXB**)
   - [CLI] Fix a few bugs in taichi gallery command (#4548) (by **Zhao Liang**)
   - [ir] Small optimizations to codegen (#4442) (by **Bob Cao**)
   - [CI] Generate manylinux2014-compatible wheels with CUDA backend in release workflow (#4550) (by **Yi Xu**)
   - [misc] Metadata update (#4539) (by **Jiasheng Zhang**)
   - [test] Parametrize the test cases with pytest.mark (#4546) (by **Frost Ming**)
   - [Doc] Update docstring for ndrange (#4486) (by **Zhao Liang**)
   - [build] Default symbol visibility to hidden for all targets (#4545) (by **Gabriel H**)
   - [autodiff] Handle multiple, mixed Independent Blocks (IBs) within multi-levels serial for-loops (#4523) (by **Mingrui Zhang**)
   - [bug] [lang] Cast the arguments of real function to the desired types (#4538) (by **Lin Jiang**)
   - [Lang] Add taichi gallery command for user to choose and run example in gui (#4532) (by **TiGeekMan**)
   - [bug] Fix bug that calling std::getenv when cpp-tests running will fail (#4537) (by **PGZXB**)
   - [vulkan] Fix performance (#4535) (by **Bob Cao**)
   - [Lang] Add ti.serialize and ti.loop_config (#4525) (by **Lin Jiang**)
   - [Lang] Support simple matrix slicing (#4488) (by **Xiangyun Yang**)
   - Update vulkan_api.cpp (#4533) (by **Bob Cao**)
   - [lang] Quick fix for mesh_local analyzer (#4529) (by **Chang Yu**)
   - [test] Show arch info in the verbose test report (#4528) (by **Frost Ming**)
   - [aot] Add binding_id of root/gtmp/rets/args bufs to CompiledOffloadedTask (#4522) (by **Ailing**)
   - [vulkan] Relax a few test precisions for vulkan (#4524) (by **Ailing**)
   - [build] Option to use LLD (#4513) (by **Bob Cao**)
   - [misc] [linux] Implement XDG Base Directory support (#4514) (by **ruro**)
   - [Lang] [refactor] Remove legacy ways to construct matrices (#4521) (by **Yi Xu**)
   - [misc] Make result of irpass::print hold more information (#4517) (by **PGZXB**)
   - [refactor] Misc improvements over AST helper functions (#4398) (by **daylily**)
   - [misc] [build] Bump catch external library 2.13.3 -> 2.13.8 (#4516) (by **ruro**)
   - [autodiff] Reduce the number of ad stack using knowledge of derivative formulas (#4512) (by **Mingrui Zhang**)
   - [ir] [opt] Fix a bug about 'continue'  stmt in cfg_build (#4507) (by **Xiangyun Yang**)
   - [Doc] Minor updates: It is recommended to type hint arguments and return values (#4510) (by **Vissidarte-Herman**)
   - [ci] Fix the taichi repo name by hardcode (#4506) (by **Frost Ming**)
   - [build] Guard dx lib search with TI_WITH_DX11 (#4505) (by **Ailing**)
   - [ci] Reduce the default device memory usage for GPU tests (#4508) (by **Bo Qiao**)
   - [Doc] Refactored Kernels and functions. (#4496) (by **Vissidarte-Herman**)
   - [aot] [refactor] Refactor AOT field API for Vulkan (#4490) (by **Bo Qiao**)
   - [ci] Fix: fill in the pull request body created by bot (#4503) (by **Frost Ming**)
   - [ci] Skip in steps rather than the whole job (#4499) (by **Frost Ming**)
   - [ci] Add a Dockerfile for building manylinux2014-compatible Taichi wheels with CUDA backend (#4491) (by **Yi Xu**)
   - [ci] Automate release publishing (#4428) (by **Frost Ming**)
   - [fix] dangling ti.func decorator in euler.py (#4492) (by **Zihua Wu**)
   - [ir] Fix a bug in simplify pass (#4489) (by **Xiangyun Yang**)
   - [test] Add test for recursive real function (#4477) (by **Lin Jiang**)
   - [Doc] Add initial variable and fragments (#4457) (by **Justin**)
   - [misc] Add a convenient script for testing compatibility of Taichi releases. (#4485) (by **Chengchen(Rex) Wang**)
   - [misc] Version bump: v0.9.1 -> v0.9.2 (#4484) (by **Chengchen(Rex) Wang**)
   - [ci] Update gpu docker image to test python 3.10 (#4472) (by **Bo Qiao**)
   - [bug] [llvm] Initialize the field to 0 when finalizing a field (#4463) (by **Lin Jiang**)
   - [Doc] Update docstrings for functions in ops (#4465) (by **Zhao Liang**)
   - [Error] Add error message when the number of elements in kernel arguments exceed (#4444) (by **Xiangyun Yang**)
   - [Doc] Update docstring for functions in misc (#4474) (by **Zhao Liang**)
   - [metal] Support device memory allocation/deallocation (#4439) (by **Ye Kuang**)
   - update docstring for exceptions (#4475) (by **Zhao Liang**)
   - [llvm] Support real function with single scalar return value (#4452) (by **Lin Jiang**)
   - [refactor] Remove LLVM logic from the generic Device interface (#4470) (by **PGZXB**)
   - [lang] Add decorator ti.experimental.real_func (#4458) (by **Lin Jiang**)
   - [ci] Add python 3.10 into nightly test and release (#4467) (by **Bo Qiao**)
   - [bug] Fix metal linker error when TI_WITH_METAL=OFF (#4469) (by **Bo Qiao**)
   - [Lang] Support sparse matrix builder datatype configuration (#4411) (by **Peng Yu**)
   - [Error] Add error for invalid snode size (#4460) (by **Lin Jiang**)
   - [aot] [refactor] Refactor AOT runtime API to use module (#4437) (by **Bo Qiao**)
   - [misc] Optimize verison check (#4461) (by **Jiasheng Zhang**)
   - [Error] Add error messages for wrong type annotations of literals (#4462) (by **Yi Xu**)
   - [misc] Remove some warnings (#4453) (by **PGZXB**)
   - [refactor] Move literal construction to expr module (#4448) (by **Yi Xu**)
   - [bug] [lang] Enable break in the outermost for not in the outermost scope (#4447) (by **Lin Jiang**)
   - [Doc] Update docstrings in misc (#4446) (by **Zhao Liang**)
   - [llvm] Support real function which has scalar arguments (#4422) (by **Lin Jiang**)
   - [Lang] Support type annotations for literals (#4440) (by **Yi Xu**)
   - [misc] Remove a unnecessary function (#4443) (by **PGZXB**)
   - [metal] Expose BufferMemoryView (#4432) (by **Ye Kuang**)
   - [Lang] Support simple matrix slicing (#4420) (by **Xiangyun Yang**)
   - [Doc] Update docstring for functions in operations (#4427) (by **Zhao Liang**)
   - [metal] Add Unified Device API skeleton code (#4431) (by **Ye Kuang**)
   - [refactor] Refactor llvm-offloaded-task-name mangling (#4418) (by **PGZXB**)
   - [Doc] Update PyTorch interface documentation (#4311) (by **Andrew Sun**)
   - [misc] Add deserialization tool for benchmarks (#4278) (by **rocket**)
   - [misc] Add matrix operations to micro-benchmarks (#4190) (by **rocket**)
   - [Error] Remove the mentioning of ti.pyfunc in the error message (#4429) (by **Lin Jiang**)
   - [metal] Add AotModuleLoader (#4423) (by **Ye Kuang**)
   - [Doc] Update docstring for functions in operations (#4413) (by **Zhao Liang**)
   - [vulkan] Support templated kernel in aot module (#4417) (by **Ailing**)
   - [vulkan] [aot] Add aot namespace Vulkan (#4419) (by **Bo Qiao**)
   - [Lang] Support kernel to return a matrix type value (#4062) (by **Xiangyun Yang**)
   - [test] Add a test for the ad_gravity example (#4404) (by **FZC**)
   - [Doc] Update docstring for functions in operations (#4392) (by **Zhao Liang**)
   - [CI] Cleanup workspace before window test (#4405) (by **Jian Zeng**)
   - [build] Enforce compatibility with manylinux2014 when TI_WITH_VULKAN=OFF (#4406) (by **Yi Xu**)
   - [ci] Update tag to projects (#4400) (by **Bo Qiao**)
   - [ci] Reduce test parallelism for m1 (#4394) (by **Bo Qiao**)
   - [aot] [vulkan] Add AotKernel and its Vulkan impl (#4387) (by **Ye Kuang**)
   - [vulkan] [aot] Move add_root_buffer to public members (#4396) (by **Gabriel H**)
   - [llvm] Remove LLVM functions related to a SNode tree from the module when the SNode tree is destroyed (#4356) (by **Lin Jiang**)
   - [test] disable serveral workflows on forks (#4393) (by **Jian Zeng**)
   - [ci] Windows build exits on the first error (#4391) (by **Bo Qiao**)
   - [misc] Upgrade test and docker image to support python 3.10 (#3986) (by **Bo Qiao**)
   - [aot] [vulkan] Output shapes/dims to AOT exported module (#4382) (by **Gabriel H**)
   - [test] Merge the py38 only cases into the main test suite (#4378) (by **Frost Ming**)
   - [vulkan] Refactor Runtime to decouple the SNodeTree part (#4380) (by **Ye Kuang**)
   - [lang] External Ptr alias analysis & demote atomics (#4273) (by **Bob Cao**)
   - [example] Fix implicit_fem example command line arguments (#4372) (by **bx2k**)
   - [mesh] Constructing mesh from data in memory (#4375) (by **bx2k**)
   - [refactor] Move aot_module files (#4374) (by **Ye Kuang**)
   - [test] Add test for exposed top-level APIs (#4361) (by **Yi Xu**)
   - [refactor] Move arch files (#4373) (by **Ye Kuang**)
   - [build] Build with Apple clang-13 (#4370) (by **Ailing**)
   - [test] [example] Add a test for print_offset example (#4355) (by **Zhi Qi**)
   - [test] Add a test for the game_of_life example (#4365) (by **0xzhang**)
   - [test] Add a test for the nbody example (#4366) (by **0xzhang**)
   - [Doc] Fix broken links (#4368) (by **Ye Kuang**)
   - [ci] Run vulkan and metal separately on M1 (#4367) (by **Ailing**)
   - [Doc] Re-structure the articles: getting-started, gui (#4360) (by **Ye Kuang**)
   - [Vulkan] Enable Vulkan device selection when using cuda (#4330) (by **Bo Qiao**)
   - [misc] Version bump: v0.9.0->v0.9.1 (#4363) (by **Ailing**)
   - [dx11] Materialize runtime, map and unmap (#4339) (by **quadpixels**)
   - [test] Add a test for simple_derivative example (#4323) (by **TinyBox**)
   - [example] Add implicit fem example (#4352) (by **bx2k**)
   - [opengl] Use element shape as compile information for OpenGL backend (#4284) (by **Haidong Lan**)
   - [ci] Exit on error windows test script (#4354) (by **Bo Qiao**)
   - [bug] Update children_offsets & stride info to align as elem_stride (#4345) (by **Ailing**)
   - [gui] Update GGUI examples to use vulkan backend if available (#4353) (by **Ailing**)
   - [ci] Use conda python for m1 jobs (#4351) (by **Ailing**)
   - [lang] Add support for operators "is" and "is not" in static scope and deprecate them (#4349) (by **Lin Jiang**)
   - [ci] Increase ci test parallelism (#4348) (by **Bo Qiao**)
   - [opengl] Remove support for dynamic snode (by **Ailing Zhang**)
   - [error] Let deprecation warnings display only once (#4346) (by **Lin Jiang**)
   - [ci] Fix generate_example_videos.py (#4347) (by **Ailing**)
   - [test] Add a test for autodiff/regression (#4322) (by **TinyBox**)
   - [ci] Install requirements and matplotlib for GPU tests (#4336) (by **Bo Qiao**)
   - [gui] [refactor] Avoid exposing different APIs with different GGUI_AVAILABLE values (#4329) (by **Yi Xu**)
   - [lang] Remove logical_and and logical_or from TaichiOperation (#4326) (by **Lin Jiang**)
   - [lang] Add deprecation warnings to atomic ops (#4325) (by **Lin Jiang**)
   - [refactor] Allow more build types from setup.py (#4313) (by **Bo Qiao**)
   - [refactor] make class Expr constructor explicit (#4272) (by **Retrospection**)
   - [doc] More revision on a new language (#4321) (by **Ye Kuang**)
   - [lang] Hide internal apis about Fields (#4302) (by **Xiangyun Yang**)
   - [Doc] Avoid log(0) problem in _funcs._randn() and update primitive_types.py (#4317) (by **Zhao Liang**)
   - [refactor] Remove Ndarray torch implementation and tests (#4307) (by **Bo Qiao**)
   - [Doc] Revise "Why a new programming language" (#4306) (by **Ye Kuang**)
   - [lang] Move sparse_matrix_builder from taichi.linalg to taichi.types (#4301) (by **Ailing**)
   - [lang] Make ti.cfg an alias of runtime cfg (#4264) (by **Ailing**)
   - [refactor] Refactor ForLoopDecoratorRecorder (#4309) (by **PGZXB**)
   - [lang] Hide dtype and needs_grad from SNode (#4308) (by **Yi Xu**)
   - [vulkan] Reduce runtime host overhead (#4282) (by **Bob Cao**)
   - [lang] Remove Matrix.value (#4300) (by **Lin Jiang**)
   - [lang] Hide internal APIs of FieldsBuilder (#4305) (by **Yi Xu**)
   - [lang] Hide pad_key and ndarray*_to_numpy in Ndarray (#4298) (by **Bo Qiao**)
   - [lang] Hide internal functions in SNode and _Root (#4303) (by **Yi Xu**)
   - [lang] Hide ndarray*_from_numpy (#4297) (by **Bo Qiao**)
   - [lang] Hide internal functions in Matrix and Struct (#4295) (by **Lin Jiang**)
   - [lang] Hide subscript in Matrix (#4299) (by **Lin Jiang**)
   - [lang] Hide initialize_host_accessor in Ndarray (#4296) (by **Bo Qiao**)
   - [lang] Hide internal functions in TaichiOperation (#4288) (by **Lin Jiang**)
   - [lang] Hide get_element_size and get_nelement in Ndarray (#4294) (by **Bo Qiao**)
   - [lang] Hide fill_by_kernel in Ndarray (#4293) (by **Bo Qiao**)
   - Hide data handle (#4292) (by **Bo Qiao**)
   - [lang] Remove CompoundType from taichi.types (#4291) (by **Ailing**)
   - [lang] Hide get_addr and type_assert in api docs (#4290) (by **Ailing**)
   - [lang] Only expose start_recording/stop_recording for now (#4289) (by **Ailing**)
   - [docs] Hide unnessary methods in annotation classes (#4287) (by **Ailing**)
   - [llvm] Use GEP for array access instead of ptrtoint/inttoptr (#4276) (by **Yi Xu**)
   - [lang] Fix bls_buffer allocation of x64 crashed in py3.10 (#4275) (by **Chang Yu**)
   - [misc] Code cleanup in benchmarks (#4280) (by **rocket**)
   - [doc] Improve operators page (#4073) (by **Lin Jiang**)
   - [spirv] Fix buffer info compare to fix external array bind point (#4277) (by **Bob Cao**)
   - [bug] Disallow function definition inside ti.func/kernel (#4274) (by **Lin Jiang**)
   - [refactor] Remove global instance of DecoratorRecorder (#4254) (by **PGZXB**)
   - [misc] Add stencil_2d to micro-benchmarks (#4176) (by **rocket**)
   - [refactor] Remove support for raise statement (#4262) (by **Lin Jiang**)
